%----------------------------------------------------------------------------------------
%	PACKAGES EN DOCUMENT CONFIGURATIE
%----------------------------------------------------------------------------------------

\documentclass[a4paper,12pt]{article}
\usepackage{graphicx}
\usepackage[english]{babel}
\usepackage{fancyhdr}
\usepackage{lastpage}
\usepackage{xifthen}
\usepackage{algorithm2e}
\usepackage{lipsum}
\usepackage{hyperref}
\usepackage[utf8]{inputenc}
\usepackage{amsmath}
\usepackage{amssymb}
\usepackage{float}
%----------------------------------------------------------------------------------------
%	HEADER & FOOTER
%----------------------------------------------------------------------------------------
\pagestyle{fancy}
  \lhead{\includegraphics[width=4.5cm]{logoUU}}		%Zorg dat het logo in dezelfde map staat
  \rhead{\footnotesize \textsc {Lab report\\ \opdracht}}
  \lfoot
    {
	\footnotesize \studentA
	\ifthenelse{\isundefined{\studentB}}{}{\\ \studentB}
	\ifthenelse{\isundefined{\studentC}}{}{\\ \studentC}
	\ifthenelse{\isundefined{\studentD}}{}{\\ \studentD}
	\ifthenelse{\isundefined{\studentE}}{}{\\ \studentE}
    }
  \cfoot{}
  \rfoot{\small \textsc {Page \thepage\ of \pageref{LastPage}}}
  \renewcommand{\footrulewidth}{0.5pt}

\fancypagestyle{firststyle}
 {
  \fancyhf{}
   \renewcommand{\headrulewidth}{0pt}
   \chead{\includegraphics[width=5.5cm]{logoUU}}
   \rfoot{\small \textsc {Page \thepage\ van \pageref{LastPage}}}
 }

\setlength{\topmargin}{-0.3in}
\setlength{\textheight}{630pt}
\setlength{\headsep}{40pt}

%----------------------------------------------------------------------------------------
%	DOCUMENT INFORMATIE
%----------------------------------------------------------------------------------------
%Geef bij ieder command het juiste argument voor deze opdracht. Vul het hier in en het komt op meerdere plekken in het document correct te staan.

\newcommand{\titel}{Implementation}			%Zelfbedachte titel
\newcommand{\opdracht}{Computer Vision Assignment 2}		%Naam van opdracht die je van docent gehad hebt
\newcommand{\docent}{Ronald Poppe}
\newcommand{\cursus}{Computer Vision}
\newcommand{\vakcode}{INFOMCV}		%Te vinden op oa Datanose
\newcommand{\datum}{\today}					%Pas aan als je niet de datum van vanaag wilt hebben
\newcommand{\studentA}{Jack van der Drift}
\newcommand{\uunetidA}{4098978}
\newcommand{\studentB}{Marjolein Zwerver}			%Uncomment de regel als je met vijf studenten werkt
\newcommand{\uunetidB}{5595363}
%\newcommand{\studentC}{Naam student 3}		%Uncomment de regel als je met drie studenten werkt
\newcommand{\uunetidC}{UUnetID student 3}
%\newcommand{\studentD}{Naam student 4}		%Uncomment de regel als je met vier studenten werkt
\newcommand{\uunetidD}{UUnetID student 4}
%\newcommand{\studentE}{Naam student 5}			%Uncomment de regel als je met vijf studenten werkt
\newcommand{\uunetidE}{UUnetID student 5}

%----------------------------------------------------------------------------------------
%	AUTOMATISCHE TITEL
%----------------------------------------------------------------------------------------
\begin{document}
\thispagestyle{firststyle}
\begin{center}
	\textsc{\Large \opdracht}\\[0.2cm]
		\rule{\linewidth}{0.5pt} \\[0.4cm]
			{ \huge \bfseries \titel}
		\rule{\linewidth}{0.5pt} \\[0.2cm]
	{\large \datum  \\[0.4cm]}
	
	\begin{minipage}{0.4\textwidth}
		\begin{flushleft} 
			\emph{Students:}\\
			{\studentA \\ {\small \uunetidA \\[0.2cm]}}
				\ifthenelse{\isundefined{\studentB}}{}{\studentB \\ {\small \uunetidB \\[0.2cm]}}
				\ifthenelse{\isundefined{\studentC}}{}{\studentC \\ {\small \uunetidC \\[0.2cm]}}
				\ifthenelse{\isundefined{\studentD}}{}{\studentD \\ {\small \uunetidD \\[0.2cm]}}
				\ifthenelse{\isundefined{\studentE}}{}{\studentE \\ {\small \uunetidE \\[0.2cm]}}
		\end{flushleft}
	\end{minipage}
~
	\begin{minipage}{0.4\textwidth}
		\begin{flushright} 
			\emph{Proffesor:} \\
			\docent \\[0.2cm]
			\emph{Course:} \\
			\cursus \\[0.2cm]
			\emph{Course code:} \\
			\vakcode \\[0.2cm]
		\end{flushright}
	\end{minipage}\\[1 cm]
\end{center}

%----------------------------------------------------------------------------------------
%	INHOUDSOPGAVE EN ABSTRACT 
%----------------------------------------------------------------------------------------

%\tableofcontents
%\begin{abstract}
%\lorem[13]
%\end{abstract}

%----------------------------------------------------------------------------------------
%	INTRODUCTIE
%----------------------------------------------------------------------------------------
\section{Video}
This is the private link to our video of the the voxel reconstruction:  

\url{https://youtu.be/7eBsb8bBXpI}


\section{ChessBoards}

To start with, we used the code from the previous assignment and modified it so it would take a video as input instead of the camera input. Here we found a known error in the opencv library where opencv tries to read the video file as an xml. To prevent this from happening we added a try catch in the code which continues if this errors occurs when we read the video files. The error still appears in the output but is of no consequence.

To calculate the camera intrinsics we use the function writeCameraIntrinsics(). This function uses the previous code to write the camera matrix and distortion coefficients to the intrinsics2.xml in the specified format. We multithreaded the call of this function, so we now write the camera intrinsics of each of the cameras at about the same time. In the first try of multithreading the function call we ran into the problem that the location of camera 1 was placed at a location which was further away from the scene than the actual location of camera 1. We solved this in the second try where we switched to using openmp.

We also changed the start time of the recognition of camera 3. This way we ignore the first part of the video in which the chessboard is not fully visible.

\subsection{Optimization Of Camera Points}
As a bonus we tried to optimize the selecting of the chessboard corners. For this we take the outer four corner points and try to determine the other points by interpolating between these four corner points. One of the downsides of using this method is that we now need to start with the corner closest to the chairs (top left corner in camera 1) in order to make it work. The other downside is that it is not as accurate as the selection of 48 corners. It does however give us a close enough approximation for the rest of the program to give a usable result.

\section{Background}
To get a background image for each of the views, we used a function called getBackground() for each camera. This function uses a given percentage of the frames, and averages these to get an `average’ background picture. At this time we have set this number to 100\% hoping that this image would have the least combined ‘distance’ to all frames and would therefore result in the best background subtraction. We would have liked to test different percentages to see which works best, but since we only use the first frame for comparison this wouldn’t be meaningful. In this case, lower percentages would most likely result in better matching percentages, as the influence of the first frame (which is always used) would be greater in the generated background image. 

\section{Thresholds}

\subsection{Finding optimal HSV thresholds}
To find the optimal HSV thresholds we first implemented a brute force method. This method loops over all possible HSV values (0..255) and compares how good each foreground image is by using the testHSV() function.

This function first compares a frame from a camera with the corresponding background. The pixels whose difference between the background and frame exceeds the HSV thresholds get a value of 1, making the final foreground image have a white foreground and black background. To get some estimate of how good this background separation is, we use a ground truth for comparison. This ground truth is an image where all foreground pixels were manually made white, while the background is black. Both images were compared using xor and all non zero values of this matrix were counted to get the number of pixels they differ. With this number we calculate a matching percentage which is the percentage of pixels from the foreground that matched the ground truth.

For all possible HSV values, the combination with the highest matching percentage is used for the optimal HSV thresholds. The downside of this method is that it takes a long time. It would take 255*255*255 which is nearly 16.6 million times that the code in the inner loop has to run to find the optimal value. To improve this, we came up with a gradient descent like approach.

\subsection{Optimizing HSV thresholds}
First, we guess the initial HSV values with the guessHSV() function. This function takes a number of evenly spaced out guesses (in this case 10) between 0 and 255. The values for h, s and v are all set to this value and the percentage of matching pixels is calculated using testHSV() to calculate the similarity between the extracted foreground for the first frame of the camera 1 and the corresponding ground truth. In the end, the value with the highest percentage will be used as a first guess.

For optimization purposes you would probably increase the number of initial guesses to get closer to the optimal solution. Guesses for which the values of h, s and v are different should also be included if your goal would be to minimise the average number of tries needed to find the optimal value. Also, creating the ground truth manually is pretty tricky: for the pixels on the edge of the foreground it is difficult to determine if they should be foreground or background pixels. Improvements could probably be made here as well.

The current best HSV values are now set to the first guess and the current best match percentage is set to the corresponding match percentage. From these current values, all possible new values for h, s and v are calculated where each can be either the same or one step size more or less compared to the current best value. So if for example the current best values are h=5, s=50 and v=60, every combination of h=4, h=5, h=6 and s=49, s=50, s=51 and v =59, v=60, v=61 are tried. In this case, the first frames for all views and with their corresponding ground truths are used. The combination of values that get the highest match percentage (if this percentage is higher than the current best value) is used for the new best HSV values. As soon as none of the match percentages are higher than the current best match percentage, we have the option to stop searching. There is a possibility though that at this point, we have reached a local maxima. To try to escape this if we are indeed in one, the step size is increased by one. In this case we would try h=3, h=5, h=7 etc. and again it check if any combination of these values results in a better match percentage. If this is the case, the HSV values are updated, the step size is reset to 1 and the process continues. If this is not the case, the step size increased again. This continues until the step size increases over a certain value (max\_ tries, in our case 10). In this case, no further progress is made and the current best HSV values are used for the sliders in the 3D scene.

Using this method, the optimal HSV values we get are h=3, s=54, v=68, with a matching rate of 98.98\%. For this method, the code in the inner loop has to run 1611 times, which is a nice improvement from the 16.6 million from the brute force method.

\subsection{Finding Optimal Erode \& Dilate Variables}

In order to get rid of noise and some of the holes in the foreground of camera 1 which has been processed with the optimal HSV values we use the erode and dilate functions of openCV. For this we use a brute force method which finds the optimal shape size and amount of times we erode and dilate. In order to get the best result we use the foreground of camera 1 which has been processed with the optimal HSV values. One thing to notice is that we erode before we dilate, this way we remove the noise instead of making it bigger.

We are justified to use brute force for this specific case since we found out after the first run that the optimal values lie within a range of 0 to 5. The inner loop, which does the erosion, dilation  and calculates the matching rate, only runs for 625 times. In the end we dilate and erode once with and object of size 3. The usage of the erode and dilate function results in a matching rate of 99.14\%. More robust results might be achieved if we also take into account the other 3 views like we did with the HSV values.

%----------------------------------------------------------------------------------------
%	REFERENTIES
%----------------------------------------------------------------------------------------
%Meer informatie hierover volgt in blok 5 van jaar 1.

\nocite{*}
\bibliographystyle{acm}
%\bibliographystyle{apalike}
%\bibliography{refs}

%----------------------------------------------------------------------------------------
%	BIJLAGEN
%----------------------------------------------------------------------------------------

%\section{Bijlage A}
%\section{Bijlage B}
%\section{Bijlage C}

\end{document}